commit 97eeedc553a51085d3d433b9ff3094f360fb2e92
Author: freddy77 <freddy77>
Date:   Tue Dec 16 15:41:18 2008 +0000

    add and reuse tds_writetext_(start|continue|end)

diff --git a/ChangeLog b/ChangeLog
index 8565a4a..d3a3627 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Dec 16 16:39:35 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/ctlib/ct.c src/dblib/dblib.c src/tds/bulk.c:
+	- add and reuse tds_writetext_(start|continue|end)
+
 Tue Dec 16 10:25:33 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
 	- add and reuse tds_bcp_init
@@ -1082,4 +1086,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2684 2008/12/16 09:26:02 freddy77 Exp $
+$Id: ChangeLog,v 1.2685 2008/12/16 15:41:18 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 8f49901..bf96853 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.308 2008/12/16 09:26:02 freddy77 Exp $ */
+/* $Id: tds.h,v 1.309 2008/12/16 15:41:18 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1620,6 +1620,10 @@ int tds_bcp_done(TDSSOCKET *tds, int *rows_copied);
 int tds_bcp_start(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 int tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 
+int tds_writetext_start(TDSSOCKET *tds, const char *objname, const char *textptr, const char *timestamp, int with_log, TDS_UINT size);
+int tds_writetext_continue(TDSSOCKET *tds, const TDS_UCHAR *text, TDS_UINT size);
+int tds_writetext_end(TDSSOCKET *tds);
+
 
 #define IS_TDS42(x) (x->major_version==4 && x->minor_version==2)
 #define IS_TDS46(x) (x->major_version==4 && x->minor_version==6)
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index 24b3bbc..43a808b 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.182 2008/12/15 05:31:14 jklowden Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.183 2008/12/16 15:41:18 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -1079,8 +1079,7 @@ ct_send(CS_COMMAND * cmd)
 	}
 
 	if (cmd->command_type == CS_SEND_DATA_CMD) {
-		tds_flush_packet(tds);
-		tds_set_state(tds, TDS_PENDING);
+		tds_writetext_end(tds);
 		ct_set_command_state(cmd, _CS_COMMAND_SENT);
 	}
 
@@ -2735,7 +2734,6 @@ CS_RETCODE
 ct_send_data(CS_COMMAND * cmd, CS_VOID * buffer, CS_INT buflen)
 {
 	TDSSOCKET *tds;
-	char writetext_cmd[512];
 
 	char textptr_string[35];	/* 16 * 2 + 2 (0x) + 1 */
 	char timestamp_string[19];	/* 8 * 2 + 2 (0x) + 1 */
@@ -2782,32 +2780,16 @@ ct_send_data(CS_COMMAND * cmd, CS_VOID * buffer, CS_INT buflen)
 		}
 		*c = '\0';
 
-		/* submit the "writetext bulk" command */
-
-		sprintf(writetext_cmd, "writetext bulk %s 0x%s timestamp = 0x%s%s",
-			cmd->iodesc->name,
-			textptr_string, timestamp_string, ((cmd->iodesc->log_on_update == CS_TRUE) ? " with log" : "")
-			);
-
-		if (tds_submit_query(tds, writetext_cmd) != TDS_SUCCEED) {
-			return CS_FAIL;
-		}
-
-		/* FIXME in this case processing all results can bring state to IDLE... not threading safe */
-		/* read the end token */
-		if (tds_process_simple_query(tds) != TDS_SUCCEED)
-			return CS_FAIL;
-
-		if (tds_set_state(tds, TDS_QUERYING) != TDS_QUERYING)
+		/* submit the writetext command */
+		if (tds_writetext_start(tds, cmd->iodesc->name,
+			textptr_string, timestamp_string, (cmd->iodesc->log_on_update == CS_TRUE), cmd->iodesc->total_txtlen) != TDS_SUCCEED)
 			return CS_FAIL;
 
 		cmd->send_data_started = 1;
-		tds->out_flag = TDS_BULK;
-		tds_put_int(tds, cmd->iodesc->total_txtlen);
 	}
 
-	tds->out_flag = TDS_BULK;
-	tds_put_n(tds, buffer, buflen);
+	if (tds_writetext_continue(tds, buffer, buflen) != TDS_SUCCEED)
+		return CS_FAIL;
 
 	return CS_SUCCEED;
 }
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index a1eb2ca..1ea3983 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.335 2008/12/15 05:31:14 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.336 2008/12/16 15:41:18 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -6298,31 +6298,19 @@ dbwritetext(DBPROCESS * dbproc, char *objname, DBBINARY * textptr, DBTINYINT tex
 			return FAIL;
 		}
 	}
-
-	if (tds_submit_queryf(dbproc->tds_socket,
-			      "writetext bulk %s 0x%s timestamp = 0x%s %s",
-			      objname, textptr_string, timestamp_string, ((log == TRUE) ? "with log" : ""))
-	    != TDS_SUCCEED) {
-		return FAIL;
-	}
-
-	/* read the end token */
-	if (tds_process_simple_query(dbproc->tds_socket) != TDS_SUCCEED)
+	
+	if (tds_writetext_start(dbproc->tds_socket, objname, 
+		textptr_string, timestamp_string, (log == TRUE), size) != TDS_SUCCEED)
 		return FAIL;
 
-	dbproc->tds_socket->out_flag = TDS_BULK;
-	tds_set_state(dbproc->tds_socket, TDS_QUERYING);
-	tds_put_int(dbproc->tds_socket, size);
-
 	if (!text) {
 		dbproc->text_size = size;
 		dbproc->text_sent = 0;
 		return SUCCEED;
 	}
 
-	tds_put_n(dbproc->tds_socket, text, size);
-	tds_flush_packet(dbproc->tds_socket);
-	tds_set_state(dbproc->tds_socket, TDS_PENDING);
+	tds_writetext_continue(dbproc->tds_socket, text, size);
+	tds_writetext_end(dbproc->tds_socket);
 
 	if (dbsqlok(dbproc) == SUCCEED && dbresults(dbproc) == SUCCEED)
 		return SUCCEED;
@@ -6422,21 +6410,17 @@ dbmoretext(DBPROCESS * dbproc, DBINT size, BYTE * text)
 
 	assert(dbproc->text_size >= dbproc->text_sent);
 
-	/* test dbproc value and state */
-	if (!dbproc || !dbproc->tds_socket || dbproc->tds_socket->out_flag != TDS_BULK)
-		return FAIL;
-
+	/* TODO this test should be inside tds_writetext_continue, currently not */
 	if (size < 0 || size > dbproc->text_size - dbproc->text_sent)
 		return FAIL;
 
 	if (size) {
-		tds_put_n(dbproc->tds_socket, text, size);
+		if (tds_writetext_continue(dbproc->tds_socket, text, size) != TDS_SUCCEED)
+			return FAIL;
 		dbproc->text_sent += size;
 
-		if (dbproc->text_sent == dbproc->text_size) {
-			tds_flush_packet(dbproc->tds_socket);
-			tds_set_state(dbproc->tds_socket, TDS_PENDING);
-		}
+		if (dbproc->text_sent == dbproc->text_size)
+			tds_writetext_end(dbproc->tds_socket);
 	}
 
 	return SUCCEED;
diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index 467f736..5d06482 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.5 2008/12/16 09:26:02 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.6 2008/12/16 15:41:19 freddy77 Exp $");
 
 #ifndef MAX
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
@@ -1063,3 +1063,50 @@ tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 
 	return TDS_SUCCEED;
 }
+
+int
+tds_writetext_start(TDSSOCKET *tds, const char *objname, const char *textptr, const char *timestamp, int with_log, TDS_UINT size)
+{
+	if (tds_submit_queryf(tds,
+			      "writetext bulk %s 0x%s timestamp = 0x%s%s",
+			      objname, textptr, timestamp, with_log ? " with log" : "")
+	    != TDS_SUCCEED) {
+		return TDS_FAIL;
+	}
+
+	/* FIXME in this case processing all results can bring state to IDLE... not threading safe */
+	/* read the end token */
+	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+		return TDS_FAIL;
+
+	/* FIXME better transiction state */
+	tds->out_flag = TDS_BULK;
+	if (tds_set_state(tds, TDS_QUERYING) != TDS_QUERYING)
+		return TDS_FAIL;
+	tds_put_int(tds, size);
+	return TDS_SUCCEED;
+}
+
+int
+tds_writetext_continue(TDSSOCKET *tds, const TDS_UCHAR *text, TDS_UINT size)
+{
+	/* TODO check state */
+	if (tds->out_flag != TDS_BULK)
+		return TDS_FAIL;
+
+	/* TODO check size letft */
+	tds_put_n(tds, text, size);
+	return TDS_SUCCEED;
+}
+
+int
+tds_writetext_end(TDSSOCKET *tds)
+{
+	/* TODO check state */
+	if (tds->out_flag != TDS_BULK)
+		return TDS_FAIL;
+
+	tds_flush_packet(tds);
+	tds_set_state(tds, TDS_PENDING);
+	return TDS_SUCCEED;
+}

